#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dialog.h>
#include <owl\radiobut.h>
#include <owl\edit.h>
#include <owl\listbox.h>
#include <owl\combobox.h>
#include <owl\scrollba.h>
#include <owl\dc.h>
#include <string.h>
#include "pr55_1.rc"

//    . 
struct
{
  char edit[81];
  BOOL radio1;
  BOOL radio2;
  BOOL radio3;
  TScrollBarData scrollerData;
  BOOL check1;
  BOOL check2;
  BOOL check3;
  TListBoxData  listBoxData;
  TComboBoxData comboBoxData;
} transBuf;	

//  .
class TApp: public TApplication
{
  public:
	 TApp():TApplication() {}
	 void InitMainWindow();
};

//   .
class TWndw : public  TFrameWindow
{
  public:
	 TWndw (TWindow *parent, const char far *title);
  protected:
         void Paint(TDC&, BOOL, TRect&);
         void CmDialog();

         DECLARE_RESPONSE_TABLE(TWndw);
};

DEFINE_RESPONSE_TABLE1 (TWndw, TFrameWindow)
	  EV_COMMAND (CM_DIALOG, CmDialog),
END_RESPONSE_TABLE;

//   .
class TDlg : public TDialog
{
  public:
    TDlg(TWindow *parent, TResId resId);
};

// TWndw::TWndw()
//    .
TWndw::TWndw(TWindow *parent, const char far *title):
			 TFrameWindow (parent, title)
{
  //     .
  Attr.X = 20;
  Attr.Y = 20;
  Attr.W = 500;
  Attr.H = 300;
  //    .
  AssignMenu(MENU_1);
  //   .
  strcpy(transBuf.edit, "Default");
  transBuf.radio1 = TRUE;
  transBuf.radio2 = FALSE;
  transBuf.radio3 = FALSE;
  transBuf.check1 = TRUE;
  transBuf.check2 = FALSE;
  transBuf.check3 = FALSE;
  transBuf.scrollerData.HighValue = 100;
  transBuf.scrollerData.LowValue = 0;
  transBuf.scrollerData.Position = 50;
  transBuf.listBoxData.AddString("ListString1", TRUE) ;
  transBuf.listBoxData.AddString("Liststring2");
  transBuf.listBoxData.AddString("ListString3");
  transBuf.listBoxData.AddString("ListString4");
  transBuf.listBoxData.AddString("ListString5");
  transBuf.listBoxData.AddString("ListString6");
  transBuf.comboBoxData.AddString("ComboString1", TRUE);
  transBuf.comboBoxData.AddString("ComboString2");
  transBuf.comboBoxData.AddString("ComboString3");
  transBuf.comboBoxData.AddString("ComboString4");
  transBuf.comboBoxData.AddString("ComboString5");
  transBuf.comboBoxData.AddString("ComboString6");
}

// TWndw::CmDialog()
//      Test Dialog  
//  Dialog,     . 
void TWndw::CmDialog()
{
  //   .
  TDialog *dialog = new TDlg(this, DIALOG_1);
  //   . 
  int result = dialog->Execute();
  // ,     
  //     OK 
  //     ,   .
  if   (result == IDOK) Invalidate();
} 

// TWndw::Paint()
//  ,    
// WM_PAINT,   , 
//    .
void TWndw::Paint(TDC &paintDC, BOOL, TRect&)
{
  TEXTMETRIC textMetrics;
  int num;
  char s[40];
  //    . 
  paintDC.GetTextMetrics(textMetrics);
  //     . 
  paintDC.SetTextAlign(TA_RIGHT);
  //     .
  TSize size = paintDC.GetTextExtent("EDIT CONTROL:", 13);
  //       . 
  paintDC.TextOut(size.cx + 12, textMetrics.tmHeight, "EDIT CONTROL:"); 
  paintDC.TextOut(size.cx + 12, textMetrics.tmHeight*2, "RADIO BUTTON:"); 
  paintDC.TextOut(size.cx + 12, textMetrics.tmHeight*3, "SCROLL BAR:"); 
  paintDC.TextOut(size.cx + 12, textMetrics.tmHeight*4, "CHECK BOX 1:"); 
  paintDC.TextOut(size.cx + 12, textMetrics.tmHeight*5, "CHECK BOX 2:"); 
  paintDC.TextOut(size.cx + 12, textMetrics.tmHeight*6, "CHECK BOX 3:");
  paintDC.TextOut(size.cx + 12, textMetrics.tmHeight*7, "LIST BOX:");
  paintDC.TextOut(size.cx + 12, textMetrics.tmHeight*8, "COMBO BOX;");
  //          .
  paintDC.SetTextAlign(TA_LEFT);
  //   .
  paintDC.SetTextColor(TColor::LtBlue);
  //     
  //  ,  
  //        .
  paintDC.TextOut(size.cx + 20, textMetrics.tmHeight, transBuf.edit);
  if (transBuf.radio1) num = 1; 
  else if (transBuf.radio2) num = 2; 
       else num = 3;
  wsprintf(s, "Radio button #%d chosen", num); 
  paintDC.TextOut(size.cx + 20, textMetrics.tmHeight*2, s);
  wsprintf(s, "%d", transBuf.scrollerData.Position); 
  paintDC.TextOut(size.cx + 20, textMetrics.tmHeight*3, s);
  if (transBuf.check1) strcpy (s, "Chosen"); 
  else strcpy(s, "Not chosen"); 
  paintDC.TextOut(size.cx + 20, textMetrics.tmHeight*4, s);
  if (transBuf.check2) strcpy(s, "Chosen");
  else strcpy(s, "Not chosen"); 
  paintDC.TextOut(size.cx + 20, textMetrics.tmHeight*5, s);
  if (transBuf.check3) strcpy(s, "Chosen");
  else strcpy(s, "Not chosen"); 
  paintDC.TextOut(size.cx + 20, textMetrics.tmHeight*6, s);
  transBuf.listBoxData.GetSelString(s, sizeof(s));
  paintDC.TextOut(size.cx + 20, textMetrics.tmHeight*7, s);
  transBuf.comboBoxData.GetSelString(s, sizeof(s));
  paintDC.TextOut(size.cx + 20, textMetrics.tmHeight*8, s);
}

//**************************************
//   TDlg.
//**************************************
// TDlg::TDlg()
//    .
TDlg::TDlg(TWindow *parent, TResId resId): TDialog (parent, resId)
{
  //  OWL-   
  //   .    
  // ,    OWL  
  //    ,     
  //     transBuf.
  new TEdit (this, ID_EDIT, sizeof(transBuf.edit));
  new TRadioButton (this, ID_RADIO1, 0);
  new TRadioButton (this, ID_RADIO2, 0);
  new TRadioButton (this, ID_RADIO3, 0);
  new TScrollBar (this, ID_SCROLLER);
  new TCheckBox (this, ID_CHECK1);
  new TCheckBox (this, ID_CHECK2);
  new TCheckBox (this, ID_CHECK3);
  new TListBox (this, ID_LISTBOX);
  new TComboBox (this, ID_COMBOBOX, 20);
  //    .
  TransferBuffer = &transBuf;
}

void TApp::InitMainWindow()
{
  TFrameWindow *wndw = new TWndw (0," ");
  SetMainWindow(wndw);
}

int OwlMain(int,char *[])
{
  return TApp().Run();
}
